import java.util.ArrayList;
import java.util.Collections;

public class mastermind{
	public int[] Code;
	public int groesteNummer;
	public boolean unique;
	
	public mastermind(int a, int b, boolean unique){
		Code = new int[a];
		groesteNummer = b;
		
		this.unique = unique; 
		if(unique){
			ArrayList<Integer> list = new ArrayList<Integer>();
			for (int i = 1; i <= b; i++) {
				list.add(new Integer(i));
			}
			
			Collections.shuffle(list);
			
			for(int i = 0; i < a; i++){
				Code[i] = list.get(i);
			}
		} else {
			for(int i = 0; i < a; i++){
				Code[i] = (int) (Math.random()*b+1);
			}
		}
	}
	
	public static void main(String[] args){
		boolean unique = true;
		int digits = 4;
		
		if(args.length > 0){
			for(int i = 0; i < args.length; i++){
				if(args[i].toLowerCase().equals("-hardmode")){ unique = false; }
				if(isNumeric(args[i])){
					digits = Integer.parseInt(args[i]);
					if(digits > 9 || digits < 1){ digits = 4;}
				}
			}
		}
		
		mastermind game = new mastermind(digits, 9, unique);
		if(game.unique){			
			System.out.println("I got a Code with " + digits + " digits, can you break it?");
			System.out.println("Input like '1 2 3 4 ... 9'");
			System.out.println("========================");	
		} else {
			System.out.println("I got a Code, can you break it?");
			System.out.println("It has " + digits + " digits and they may appear more than once.");
			System.out.println("Input like '1 2 3 4 ... 9'");
			System.out.println("========================");	
		}
		
		int[] Input;
		for(int i = 1; i <= 10; i++){
			Input = game.Eingabe("Enter Code");
			System.out.println("                           ==== " + game.gotright(Input) + " right and " + game.rightcolor(Input) + " wrong place, " + (11 - i) + " tries left ====");
			if(game.gotright(Input) == game.Code.length){
				System.out.println("You won!");
				return;
			}
		}
		System.out.println("You lost!");
		String theCode = "";
		
		for(int i = 0; i < game.Code.length; i++){
			theCode = theCode + " " + game.Code[i];
		}
		
		System.out.println("The Code was " + theCode);
		
	}
	
	public int gotright(int[] Input){
		int r = 0;
		for(int i = 0; i < Code.length; i++){
			if(Code[i] == Input[i]){r++;}
		}
		return(r);
	}
	
	public int rightcolor(int[] Input){
		boolean[] check = new boolean[Code.length];
		int r = 0;
		
		for(int j = 0; j < Input.length; j++){
			for(int i = 0; i < Code.length; i++){
				if(!check[i] && Code[i] == Input[j]){
					check[i] = true;
					r++;
					break;
				}
			}
		}
		return(r - gotright(Input));
	}
	
	public int[] Eingabe(String Frage){
		System.out.print(Frage + ": ");
		String st = System.console().readLine(); //liest nur die Eingabe, nicht den Text vorher
		
		while(st.split(" ").length != Code.length){
			System.out.print(Frage + ": ");
			st = System.console().readLine();
		}
		
		st = st.replace("  ", " ");
		String[] s = st.split(" "); 
		
		int[] r = new int[Code.length];
		
		for(int i = 0; i < s.length; i++){
			r[i] = Integer.parseInt(s[i]);
			if(r[i] > groesteNummer || r[i] < 1){return(Eingabe(Frage));}
		}

		return(r);
	}
	
	public static boolean isNumeric(String s) {
		return s.matches("\\d+");
	}
}